//
//  FLEXO II - Programa para clculo de propriedades de sees delgadas
//  Copyright (C) 1999  Maurcio C. Antunes (mantunes@sc.usp.br)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//


#if !defined(delgadaview_h)
#define delgadaview_h

#include <owl/docview.h>

#include "dagoapp.rh"

#include "delgadadoc.h"

#include <pointsizerect.hpp>

#include <map>

class TDelgadaView : public TWindowView {
  public:
    TDelgadaView(TDocument& doc, TWindow* parent = 0);
    virtual ~TDelgadaView();

//Escala coordenadas de janela/coordenadas reais
protected:
  double x_no_zero, y_no_zero;
  double dreal_djanela;
  int EscalarDistancia_dtoi (double); // Ignora sinal
  double EscalarDistancia_itod (int); // Ignora sinal
  int EscalarX_dtoi (double);
  double EscalarX_itod (int);
  int EscalarY_dtoi (double);
  double EscalarY_itod (int);
  template_point<double> Escalar(TPoint);
  TPoint Escalar(template_point<double>);
  template_rect<double> Escalar(TRect);
  TRect Escalar(template_rect<double>);
  void Fit (TRect,template_rect<double>);
  bool NotSizedYet;

//Dados gerais
protected:
  TDelgadaDoc& delgada_doc;
  enum Direcao {horizontal,vertical};
  int que_fazer;
  int que_fazer_enable;
  template_point<double> pmouse_d;
  TPoint pmouse_i;
  bool ha_last_pmouse_d;
  template_point<double> last_pmouse_d;
  bool ha_last_pmouse_i;
  TPoint last_pmouse_i;
  bool ha_cota,ha_cota_x,ha_cota_y;
  int i_cota;
  bool ha_trecho;
  int i_trecho;
  bool ha_distancia;
  int i_distancia;
  eixo eixo_distancia;
  int prum_lado_ou_pro_outro;

  int que_mostrar;
  int que_mostrar_enable;

  std::map<int,string,std::less<int> > valores_texto;


//Funes para desenhar
protected:
  int random_source; // Semente para nmeros aleatrios usado para bagunar seo.
  enum DesenharOuApagar {desenhar,apagar};
  void DesenharTodasAsCotas (TDC&);
  void DesenharSecao (TDC&);
  void DesenharTodasAsDistancias (TDC&);
  void DesenharPreviewR2_NOT (TDC& dc);
  void Desenhar_CG_Eixos_K_Circulo_D_Origem (TDC& dc);
  void Escrever_w (TDC& dc);

public:
  virtual void Paint(TDC& dc, bool erase, TRect& rect);
  virtual void SetupWindow();

protected:
//    void CeIniciarescala(TCommandEnabler &tce);
//    void CmIniciarescala();
//    void CeDelgadaredo(TCommandEnabler &tce);
//    void CmDelgadaredo();
//    void CeDelgadaundo(TCommandEnabler &tce);
//    void CmDelgadaundo();
//    void CeIntroduzircotas(TCommandEnabler &tce);
//    void CmIntroduzircotas();
    void EvLButtonDown(uint modKeys, TPoint& point);
//    void CeIntroduzirsecao(TCommandEnabler &tce);
//    void CmIntroduzirsecao();
    void EvMouseMove(uint modKeys, TPoint& point);
    void EvRButtonDown(uint modKeys, TPoint& point);
//    void CeIntroduzirdistancias(TCommandEnabler &tce);
//    void CmIntroduzirdistancias();
//    void CeModificardistancias(TCommandEnabler &tce);
//    void CmModificardistancias();
//    void CeMaozinha(TCommandEnabler &tce);
//    void CmMaozinha();
    void EvLButtonUp(uint modKeys, TPoint& point);
//    void CeModificarespessuras(TCommandEnabler &tce);
//    void CmModificarespessuras();
//    void CmEixoAngulo();
//    void CeFixarorigem(TCommandEnabler &tce);
//    void CmFixarorigem();
//    void CmFitall();
//    void CmApagardistancias();
//    void CmApagarsecao();
//    void CmApagartudo();
//    void CmCalculos();

    void CeTextoarea(TCommandEnabler &tce);
    void CeTextocg(TCommandEnabler &tce);
    void CeTextod(TCommandEnabler &tce);
    void CeTextoiw(TCommandEnabler &tce);
    void CeTextoix(TCommandEnabler &tce);
    void CeTextoiy(TCommandEnabler &tce);
    void CeTextojt(TCommandEnabler &tce);
    void CeTextok(TCommandEnabler &tce);
    void CeTextor(TCommandEnabler &tce);
    void CeTextotetax(TCommandEnabler &tce);
    void CeTextofechada(TCommandEnabler &tce);
    void CeTextodescontinua(TCommandEnabler &tce);

    void CeMostrarcgeixo(TCommandEnabler &tce);
    void CeMostrard(TCommandEnabler &tce);
    void CeMostrardistorig(TCommandEnabler &tce);
    void CeMostrarespessuras(TCommandEnabler &tce);
    void CeMostrarkcirculo(TCommandEnabler &tce);
    void CeMostrarsetorial(TCommandEnabler &tce);
    void CeMostrarbaguncado(TCommandEnabler &tce);

    void CeComandoredo(TCommandEnabler &tce);
    void CmComandoredo();
    void CeComandoundo(TCommandEnabler &tce);
    void CmComandoundo();
    void CeComandoborracha(TCommandEnabler &tce);
    void CmComandoborracha();
    void CeComandodistancias(TCommandEnabler &tce);
    void CmComandodistancias();
    void CeComandomaozinha(TCommandEnabler &tce);
    void CmComandomaozinha();
    void CeComandosecao(TCommandEnabler &tce);
    void CmComandosecao();
    void CeComandotesoura(TCommandEnabler &tce);
    void CmComandotesoura();
    void CeComandozoom(TCommandEnabler &tce);
    void CmComandozoom();
    void CeComandoorigem(TCommandEnabler &tce);
    void CmComandoorigem();
    void CeComandometafile(TCommandEnabler &tce);
    void CmComandometafile();

    void EvSize(uint sizeType, TSize& size);
    bool VnRevert(bool);
    bool VnVouEscalar(double*);
    void EvCaptureChanged(HWND);
    void CmComandosmostrar(WPARAM);
DECLARE_RESPONSE_TABLE(TDelgadaView);
};


#endif  // delgadaview_h 

