//
//  FLEXO II - Programa para clculo de propriedades de sees delgadas
//  Copyright (C) 1999  Maurcio C. Antunes (mantunes@sc.usp.br)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//


#if !defined(dialogos_h)
#define dialogos_h

#include <owl/dialog.h>
#include <owl/edit.h>
#include <owl/static.h>
#include <owl/radiobut.h>
#include <owl/checkbox.h>

#include "dagoapp.rh"

class SplashDialog : public TDialog {
  public:
    SplashDialog(TWindow* parent, TResId resId = IDD_SPLASH, TModule* module = 0);
    virtual ~SplashDialog();
    virtual void SetupWindow();

  protected:
    TEdit* gnu_txt;
    TStatic* version;
};

class TZoomTipo : public TDialog {
  public:
    TZoomTipo(TWindow* parent, TResId resId = IDD_ZOOMTIPO, TModule* module = 0);
    virtual ~TZoomTipo();
    virtual void TransferData(TTransferDirection direction);
    enum tipotp {comprimir,expandir,fit_all};
    tipotp Tipo () {return tipo;};
  protected:
    tipotp tipo;
    TRadioButton* radio1;
    TRadioButton* radio2;
    TRadioButton* radio3;
};

class TBorrachaDialog : public TDialog {
  public:
    TBorrachaDialog(TWindow* parent, TResId resId = IDD_BORRACHA, TModule* module = 0);
    virtual ~TBorrachaDialog();
    virtual void TransferData(TTransferDirection direction);
    enum escolhatype {tudo,secao,distancias,itens};
    escolhatype Escolha () {return escolha;};
    void SetDados (bool temsecao_,bool temdistancias_)
    {
      temsecao = temsecao_;
      temdistancias = temdistancias_;
    };
  protected:
    escolhatype escolha;
    bool temsecao,temdistancias;
    TRadioButton* radio1;
    TRadioButton* radio2;
    TRadioButton* radio3;
    TRadioButton* radio4;
};

class TLerEspessura : public TDialog {
  public:
    TLerEspessura(TWindow* parent, TResId resId = IDD_LERESPESSURA, TModule* module = 0);
    virtual ~TLerEspessura();
    virtual void TransferData(TTransferDirection direction);
    void SetDados (double esp,bool tod = false);
    void GetDados (double& esp,bool& tod);
  protected:
    double Espessura;
    bool Todos;
    TCheckBox* CheckBoxTodos;
    TEdit* EditControlEspessura;
};

class TLerDistancia : public TDialog {
  public:
    TLerDistancia(TWindow* parent, TResId resId = IDD_LERDISTANCIA, TModule* module = 0);
    virtual ~TLerDistancia();
    void SetDados (double dist,bool Escal = false);
    void GetDados (double& dist,bool& Escal);
    void TravarEscalar();
    virtual void TransferData(TTransferDirection direction);
  protected:
    double Distancia;
    bool Escalar;
    bool esc_comp;
    TEdit* EditControlDistancia;
    TCheckBox* CheckBoxEscalar;
};

#endif  // dialogos_h
