//
//  FLEXO II - Programa para clculo de propriedades de sees delgadas
//  Copyright (C) 1999  Maurcio C. Antunes (mantunes@sc.usp.br)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//

#include <owl/pch.h>

#include <do_undo.hpp>

#include "delgadadoc.h"


TDo_Undo::TDo_Undo (TDelgadaDoc& d) : delgada_doc(d)
{
}
TDo_Undo::~TDo_Undo ()
{
}
void
TDo_Undo::Do()
{
  Before(doing);
  ActualDo();
  After(doing);
}
void
TDo_Undo::Undo()
{
  Before(undoing);
  ActualUndo();
  After(undoing);
}
void
TDo_Undo::ActualDo()
{              
}
void
TDo_Undo::ActualUndo()
{
}
void
TDo_Undo::Before(TDo_Undo::DoingOrUndoing)
{
}
void
TDo_Undo::After(TDo_Undo::DoingOrUndoing)
{
  delgada_doc.NotifyViews(vnRevert);
}
