//
//  FLEXO II - Programa para clculo de propriedades de sees delgadas
//  Copyright (C) 1999  Maurcio C. Antunes (mantunes@sc.usp.br)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//

#include <owl/pch.h>

#include <textgadgeteneblavel.hpp>



namespace {

  class TTextGadgetEneblavelEnabler : public TCommandEnabler {
  public:
    TTextGadgetEneblavelEnabler(TWindow::THandle hReceiver, TTextGadgetEneblavel* g)
    :
      TCommandEnabler(g->GetId(), hReceiver),
      Gadget(g)
    {
    }

    void  Enable(bool);
    void  SetText(const char far*);
    void  SetCheck(int);

  protected:
    TTextGadgetEneblavel*  Gadget;
  };
};

void
TTextGadgetEneblavelEnabler::Enable(bool enable)
{
  TCommandEnabler::Enable(enable);
  Gadget->SetEnabled(enable);
}

void
TTextGadgetEneblavelEnabler::SetText(const char far* texto)
{
  Gadget->SetText(texto);
}

void
TTextGadgetEneblavelEnabler::SetCheck(int)
{
}


void
TTextGadgetEneblavel::CommandEnable()
{
  PRECONDITION(Window);

  if (Window->GetHandle()) {
    Window->HandleMessage(
      WM_COMMAND_ENABLE,
      0,
      TParam2((TCommandEnabler*)&TTextGadgetEneblavelEnabler(*Window, this))
    );
  }
}

